# class Bundler::Source::Path::Installer

### Attributes

spec[R]

### Public Class Methods

new(spec, options = {}) click to toggle source

    # File lib/bundler/source/path/installer.rb, line 9
    def initialize(spec, options = {})
      @options            = options
      @spec               = spec
      @gem_dir            = Bundler.rubygems.path(spec.full_gem_path)
      @wrappers           = true
      @env_shebang        = true
      @format_executable  = options[:format_executable] || false
      @build_args         = options[:build_args] || Bundler.rubygems.build_args
      @gem_bin_dir        = "#{Bundler.rubygems.gem_dir}/bin"
      @disable_extensions = options[:disable_extensions]

      if Bundler.requires_sudo?
        @tmp_dir = Bundler.tmp(spec.full_name).to_s
        @bin_dir = "#{@tmp_dir}/bin"
      else
        @bin_dir = @gem_bin_dir
      end
    end

### Public Instance Methods

post_install() click to toggle source

    # File lib/bundler/source/path/installer.rb, line 28
    def post_install
      SharedHelpers.chdir(@gem_dir) do
        run_hooks(:pre_install)

        unless @disable_extensions
          build_extensions
          run_hooks(:post_build)
        end

        generate_bin unless spec.executables.nil? || spec.executables.empty?

        run_hooks(:post_install)
      end
    ensure
      Bundler.rm_rf(@tmp_dir) if Bundler.requires_sudo?
    end

### Private Instance Methods

generate_bin() click to toggle source
Calls superclass method

    # File lib/bundler/source/path/installer.rb, line 47
    def generate_bin
      super

      if Bundler.requires_sudo?
        SharedHelpers.filesystem_access(@gem_bin_dir) do |p|
          Bundler.mkdir_p(p)
        end
        spec.executables.each do |exe|
          Bundler.sudo "cp -R #{@bin_dir}/#{exe} #{@gem_bin_dir}"
        end
      end
    end

run_hooks(type) click to toggle source

    # File lib/bundler/source/path/installer.rb, line 60
    def run_hooks(type)
      hooks_meth = "#{type}_hooks"
      return unless Gem.respond_to?(hooks_meth)
      Gem.send(hooks_meth).each do |hook|
        result = hook.call(self)
        next unless result == false
        location = " at #{$1}" if hook.inspect =~ /@(.*:\d+)/
        message = "#{type} hook#{location} failed for #{spec.full_name}"
        raise InstallHookError, message
      end
    end